-- Global Variables
HealVsDamage_UNIT_COMBAT = "UNIT_COMBAT"
HealVsDamage_UNIT_POWER = "UNIT_POWER"
HealVsDamage_TARGET_CHANGED = "PLAYER_TARGET_CHANGED"
HealVsDamage_values = HealVsDamage_Data:new()
HealVsDamage_debug = false

-- Functions

function HealVsDamage_OnLoadEvent(frame)
	frame:RegisterEvent(HealVsDamage_UNIT_COMBAT)
	frame:RegisterEvent(HealVsDamage_UNIT_POWER)
	frame:RegisterEvent(HealVsDamage_TARGET_CHANGED)
	print("Heal Vs. Damage Healer AddOn 0.0.1 Loaded")
end

function HealVsDamage_EventHandler(self, event, ...)
	local args = {...}
	
	if event == HealVsDamage_UNIT_COMBAT then
		HealVsDamage_CombatEvent(args[1], args[2], args[4])
	elseif event == HealVsDamage_TARGET_CHANGED then
		HealVsDamage_TargetChanged()
	elseif event == HealVsDamage_UNIT_POWER then
		HealVsDamage_UnitPower(args[1], args[2]);
	end
end

function HealVsDamage_UnitPower(unit, resource)
	isPlayer = unit == "player"
	if not isPlayer then
		return
	end
	
	isMana = resource == "MANA"
	if not isMana then
		return
	end
	
	HealVsDamage_values:updateMana(UnitPower("player", SPELL_POWER_MANA))
end

function HealVsDamage_TargetChanged()
	if UnitHealth("target") == 0 then
		HealVsDamageFrame:Hide()
		HealVsDamageFrameMana:Hide()
	else
		HealVsDamage_values = HealVsDamage_Data:new()
		
		-- Reset mana usage bar
		mana = UnitPower("player", SPELL_POWER_MANA)
		HealVsDamage_values:updateMana(mana)
		HealVsDamage_values:updateMana(mana)
		
		HealVsDamageFrame:Show()
		HealVsDamageFrameMana:Show()
		HealVsDamage_UpdateFrames()
	end
end

function HealVsDamage_CombatEvent(unit, action, value)
	isTarget = unit == "target"

	if HealVsDamage_debug then
		isTargetString = "false"
	
		if isTarget then
			isTargetString = "true"
		end
		
		print("Unit: " .. unit .. ", Action: " .. action .. ", Value: " .. value .. ", isTarget: " .. isTargetString)
	end
	if not isTarget then
		return
	end
	
	if HealVsDamage_debug then
		print("Event will be registered")
	end
	
	if action == "HEAL" then
		HealVsDamage_values:addHealing(value)
	elseif action == "WOUND" then
		HealVsDamage_values:addDamage(value)
	end
	
	HealVsDamage_UpdateFrames();
end

function HealVsDamage_UpdateFrames_Mana()
	val = HealVsDamage_values
	
	used = val:getManaUsage()
	
	if used <= 0 then
		HealVsDamage_Mana:SetWidth(0)
		return
	end
	
	maxMana = UnitPowerMax("player", SPELL_POWER_MANA)
	
	usedPercentage = used * HealVsDamageFrameMana:GetWidth() / maxMana
	HealVsDamage_Mana:SetWidth(usedPercentage)
end

function HealVsDamage_UpdateFrames_HealDamage()
	sum = HealVsDamage_values:getDamageAndHealingSum()
	if sum == 0 then
		HealVsDamage_Damage:SetWidth(0)
		HealVsDamage_Heal:SetWidth(0)
		return
	end
	
	val = HealVsDamage_values
	
	healPercentage = val:getHealing() * HealVsDamageFrame:GetWidth() / sum
	dmgPercentage = val:getDamage() * HealVsDamageFrame:GetWidth() / sum
	
	HealVsDamage_Damage:SetWidth(dmgPercentage)
	HealVsDamage_Heal:SetWidth(healPercentage)
end

function HealVsDamage_UpdateFrames()
	HealVsDamage_UpdateFrames_HealDamage();
	HealVsDamage_UpdateFrames_Mana();
end
