-- Data Structure
HealVsDamage_Data = {
	damage = {},
	healing = {},
	mana = { 0, 0 }
}
-- Methods

function HealVsDamage_Data:new(o)
	o = o or {}
	setmetatable(o, self)
	self.__index = self
	return o;
end

function HealVsDamage_Data:addDamage(value)
	combat = HealVsDamage_Combat:new()
	combat.value = value

	table.insert(self.damage, combat)
end

function HealVsDamage_Data:addHealing(value)
	combat = HealVsDamage_Combat:new()
	combat.value = value

	table.insert(self.healing, combat)
end

function HealVsDamage_Data:cleanTable(list)
	timeout = 5
	didRemove = true
	currTime = time()
	while didRemove do
		if #list == 0 then
			-- Nothing to remove
			return
		end
		
		item = list[1]
		timeDiff = currTime - item.timestamp
		if timeDiff >= timeout then
			table.remove(list, 1)
		else
			didRemove = false
		end
	end
end

function HealVsDamage_Data:updateMana(newMana)
	self.mana[0] = self.mana[1]
	self.mana[1] = newMana
end

function HealVsDamage_Data:getManaUsage()
	return self.mana[0] - self.mana[1];
end

function HealVsDamage_Data:getHealing()
	self:cleanTable(self.healing)
	heal = 0
	for i=1,#self.healing do
		heal = heal + self.healing[i].value
	end
	
	return heal
end

function HealVsDamage_Data:getDamage()
	self:cleanTable(self.damage)
	dmg = 0
	for i=1,#self.damage do
		dmg = dmg + self.damage[i].value
	end
	
	return dmg
end

function HealVsDamage_Data:getDamageAndHealingSum()
	return self:getHealing() + self:getDamage()
end